﻿using System;
using System.Collections.Generic;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.EvolutionaryTracking {
  [StorableClass]
  public class LineageExplorer : Item {
    public ISymbolicExpressionTreeGenealogyGraph GenealogyGraph { get; set; }
    public IList<Tuple<ISymbolicExpressionTree, double>> Trees { get; set; }
    public int Generations { get; set; }

    private LineageExplorer(bool deserializing) : base(deserializing) { }
    private LineageExplorer(LineageExplorer original, Cloner cloner) : base(original, cloner) { }
    public LineageExplorer() { }
    public override IDeepCloneable Clone(Cloner cloner) { return new LineageExplorer(this, cloner); }
  }
}
